﻿using Xamarin.Forms;

namespace HeaderTest
{
    public class HeaderPage : ContentPage
    {
        private bool _useTitleImage = true;
        //private bool _useTitleImage = false;
         
        private Label _headerLabel;
        public string HeaderLabel
        {
            get { return _headerLabel.Text; }
            set { _headerLabel.Text = value; }
        }

        private ContentView _headerPageContent;
        public View HeaderPageContent
        {
            set { _headerPageContent.Content = value; }
        }

        public new Color BackgroundColor
        {
            set { _headerPageContent.BackgroundColor = value; }
        }

        public HeaderPage()
        {
            CreateHeaderPage(null, string.Empty, true, ViewBackground.None);
        }
        public HeaderPage(ViewBackground background)
        {
            CreateHeaderPage(null, string.Empty, true, background);
        }
        public HeaderPage(bool scrollEnabled = true, ViewBackground background = ViewBackground.None)
        {
            CreateHeaderPage(null, string.Empty, scrollEnabled, background);
        }

        public HeaderPage(string headerText, bool scrollEnabled = true, ViewBackground background = ViewBackground.None)
        {
            CreateHeaderPage(null, headerText, scrollEnabled, background);
        }

        public HeaderPage(Layout page, bool scrollEnabled = true, ViewBackground background = ViewBackground.None)
        {
            CreateHeaderPage(page, string.Empty, scrollEnabled, background);
        }

        public HeaderPage(Layout page, string headerText, bool scrollEnabled = true, ViewBackground background = ViewBackground.None)
        {
            CreateHeaderPage(page, headerText, scrollEnabled, background);
        }

        private void CreateHeaderPage(Layout page, string headerText, bool scrollEnabled, ViewBackground background)
        {

            Icon = "hamenu.png"; 
            Title = "Memory Test";  

            _headerPageContent = new ContentView
            {
                Content = page,
                BackgroundColor = Color.White,
                HorizontalOptions = LayoutOptions.FillAndExpand,
                VerticalOptions = LayoutOptions.FillAndExpand,
                Margin = 20
            };

            // works
            /*Content = new StackLayout
            {
                Children = { _headerPageContent }
            };*/

            // doesn't work
           Content = new ScrollView
            {
                Content = _headerPageContent
            };

        }

        private async void BackTappedCallback(object o)
        {
            if (App.Navigation.NavigationStack.Count > 1)
            {
                await App.Navigation.PopAsync();
            }
        }

        protected override void OnDisappearing()
        {
            base.OnDisappearing(); 
            if (_useTitleImage)
            {
                NavigationPage.SetTitleIcon(this, null);
            }

        }

        protected override void OnAppearing()
        {
            base.OnAppearing();
            if (_useTitleImage)
            {
                NavigationPage.SetTitleIcon(this, "main_logo.png");
            }

        } 

    }
}
