﻿using System.Collections.Generic;
using Xamarin.Forms;

namespace HeaderTest
{
    class Item
    {
        public string Name { get; set; }
        public int Key { get; set; }
    }
    class MasterPage : ContentPage
    {
        public MasterPage()
        {
            var items = new List<Item>
            {
                new Item() {Name = "Test Page", Key = 1},
            };

            var cell = new DataTemplate (typeof (TextCell));
            cell.SetBinding (TextCell.TextProperty, "Name");

            var menuView = new ListView(ListViewCachingStrategy.RetainElement)
            {
                ItemTemplate = cell,
                ItemsSource = items,
                HasUnevenRows = true,
            };
            menuView.ItemSelected += OnMenuClicked; 

            Content = menuView;
            Title = "Test App";
            Icon = "hamenu.png";


        }

        private void OnMenuClicked(object sender, SelectedItemChangedEventArgs e)
        {
            var item = (Item)e.SelectedItem;
            Page next;
            switch (item.Key)
            {
                case 1:
                    next = new TestPage();
                    break;
                default:
                    next = new TestPage();
                    break;
            }
            //var detail = new NavigationPage(next);
            var mainPage = ((MasterDetailPage) Parent);
            mainPage.Detail = next;
            mainPage.IsPresented = false;
        }

    }
}
